package com.streambase.contrib.chartdemo.models;

import java.util.Date;
import java.util.Observable;
import java.util.Observer;
import org.jfree.data.time.Day;
import org.jfree.data.time.RegularTimePeriod;
import org.jfree.data.time.TimeSeries;

public class DataModel extends Observable {

	public TimeSeries StockPrices;
	
	public Number getLastInTimeSeries()  { return StockPrices.getValue(StockPrices.getItemCount() - 1); }
	public Number getFirstInTimeSeries() { return StockPrices.getValue(0); }
	public Number getItemCount( int n )  { return StockPrices.getValue(n); }
	public int    getSeriesCount()       { return StockPrices.getItemCount(); }

	public void AddViewers( Observer[] views )
	{
		for( Observer observer : views )
		{
			this.addObserver(observer);
		}
	}

	@SuppressWarnings("deprecation")
	public void addValueToTimeSeries( Date timestamp, double stockPrice )
	{
		RegularTimePeriod rtp = RegularTimePeriod.createInstance( Day.class, timestamp, RegularTimePeriod.DEFAULT_TIME_ZONE );
		StockPrices.addOrUpdate( rtp, stockPrice );
		setChanged();
		notifyObservers();
	}

	@SuppressWarnings("deprecation")
	public DataModel()
	{
		this.StockPrices = new TimeSeries( "Data", Date.class );	
	}

}
